(in-package "URI-TEMPLATE.TEST")

#.(enable-uri-template-syntax)

(defun run-tests ()
  (run-interpolation-tests)
  (run-destructuring-tests))
  
(defun run-interpolation-tests ()
  (let ((baz 1)
        (bar "bar"))
    (assert (string= #Uhttp://www.foo.com/bar/{baz}
                     "http://www.foo.com/bar/1"))
    (assert (string= #Uhttp://www.foo.com/bar/{bar}/{baz}
                     "http://www.foo.com/bar/bar/1"))
    (assert (string= #Uhttp://www.foo.com/bar/{bar}{baz}
                     "http://www.foo.com/bar/bar1"))
    (assert (string= #Uhttp://www.foo.com/bar?foo={"^BAZ"}
                     "http://www.foo.com/bar?foo=%5EBAZ"))))

(defun run-destructuring-tests ()
  (assert (equalp (uri-template-bind (#Uhttp://www.factory.com/orders/{part}/{(#'parse-integer number)} "http://www.factory.com/orders/widget/1234")
                    (list part number %uri-host))
                  '("widget" 1234 "www.factory.com")))
  (assert (equalp (bind-standard-uri-components "https://www.google.com/dir/1/2/search.html?arg=0-a&arg1=1-b&amp;arg3-c#hash"
                    (list %uri-protocol %uri-host %uri-path %uri-directory %uri-file %uri-query-string %uri-hash))
                  '("https" "www.google.com" "/dir/1/2/search.html" "/dir/1/2/" "search.html" "arg=0-a&arg1=1-b&amp;arg3-c" "hash"))))
